CDays12.namespace("CDays12.ListViewModel");

CDays12.ListViewModel = (function() {
    var ctor = function() {

        //Rent-a-constructor pattern: ereditarietà
        CDays12.ComponentModel.BaseViewModel.apply(this, arguments);

        //caching della variabile di contesto this
        var self = this;

        this.itemList = ko.observableArray();

        this.viewDetailCommand = function(item) {
            //messenger() è ereditato da BaseViewModel
            self.messenger().sendMessage("itemDetailSelected", item);
        };

        this.viewDetailClearCommand = function() {
            self.messenger().sendMessage("itemDetailSelected", null);
        };

        CDays12.System.executeRestGet("/resources/data.txt", function(responseData) {
            for (var i = 0; i < responseData.items.length; i++) {
                //uso della variabile di caching del contesto del costruttore
                //la variabile di contesto this della funzione di callback non è l'oggetto in costruzione
                self.itemList.push(responseData.items[i]);
            }
        }, function(error) {
            alert("Error fetching remote data: " + error);
        });
    };
    ctor.prototype = {
        constructor: CDays12.ListViewModel,
        name: "CDays12.ListViewModel",
        version: "1.0"
    };
    return ctor;
}());