CDays12.namespace("CDays12.Messenger");

CDays12.Messenger = (function() {
    var ctor;
    var messages = [];

    ctor = function () {
        this.subscribeMessage = function (messageName, callback) {
            if(typeof messageName !== "string") {
                return;
            }
            if (typeof callback !== "function") {
                return;
            }
            if(typeof messages[messageName] === "undefined") {
                messages[messageName] = [];
            }
            messages[messageName].push(callback);
        };
        this.sendMessage = function (messageName, message) {
            if(typeof messageName !== "string") {
                return;
            }
            if(typeof messages[messageName] === "undefined") {
                return;
            }
            for(var i = 0, max = messages[messageName].length; i < max; i++) {
                messages[messageName][i](message);
            }
        };
    };

    ctor.prototype = {
        constructor: CDays12.Messenger,
        name: "CDays12.Messenger",
        version: "1.0"
    };
    return  ctor;
}());