//Namespace pattern

var CDays12 = CDays12 || {};

CDays12.namespace = function (ns_string) {
    var parts = ns_string.split('.'),
        parent = CDays12;
    if (parts[0] === "CDays12") {
        parts = parts.slice(1);
    }
    for (var i = 0; i < parts.length; i += 1) {
        if (typeof parent[parts[i]] === "undefined") {
            parent[parts[i]] = {};
        }
        parent = parent[parts[i]];
    }
    return parent;
};

//Module pattern: usato come namespace che restituisce un oggetto "utility"

CDays12.namespace("CDays12.System");

CDays12.System = (function() {
    var executeRestPut = function(requestUrl, requestData, responseCallback, errorCallback) {
        jQuery.ajax({
            type: "PUT",
            contentType: "application/json; charset=utf-8",
            url: requestUrl,
            data: JSON.stringify(requestData),
            dataType: "json",
            success: function(data, textStatus, jqXHR) {
                if (responseCallback) {
                    responseCallback(data);
                }
            },
            error: function(jqXHR, textStatus, errorThrown){
                if (errorCallback) {
                    errorCallback(errorThrown);
                }
            }
        });
    };
    var executeRestGet = function(requestUrl, responseCallback, errorCallback) {
        jQuery.ajax({
            type: "GET",
            url: requestUrl,
            dataType: "json",
            success: function(data, textStatus, jqXHR) {
                if (responseCallback) {
                    responseCallback(data);
                }
            },
            error: function(jqXHR, textStatus, errorThrown){
                if (errorCallback) {
                    errorCallback(errorThrown);
                }
            }
        });
    };
    return {
        executeRestPut: executeRestPut,
        executeRestGet: executeRestGet
    }
}());